#define  F_CPU    2000000UL
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "hd44780.h"

int main(void) {
	
	// wejcia enkodera
	PORTCFG.MPCMASK	=	0b00000011;					// wybr pinw 0 i 1 do konfiguracji
	PORTC.PIN0CTRL	=	PORT_ISC_LEVEL_gc |			// reagowanie na poziom niski
						PORT_OPC_PULLUP_gc;			// podcignicie do zasilania
	
	// konfiguracja systemu zdarze
	EVSYS.CH0MUX	=	EVSYS_CHMUX_PORTC_PIN0_gc;	// pin C0 wywouje zdarzenie
	EVSYS.CH0CTRL	=	EVSYS_QDEN_bm|				// wczenie dekodera w systemie zdarze
						EVSYS_DIGFILT_8SAMPLES_gc;	// filtr cyfrowy	
	
	// konfiguracja timera
	TCC0.CTRLA		=	TC_CLKSEL_EVCH0_gc;			// taktowanie zegarem 2MHz
	TCC0.CTRLD		=	TC_EVACT_QDEC_gc |			// wczenie dekodera kwadraturowego
						TC_EVSEL_CH0_gc;			// dekoder zlicza impulsy z kanau 0 sys zdarze

	// wywietlacz
	LcdInit();
	
	while(1) {
		// wywietlenie aktualnej wartoci licznika CNT
		// CNT = ...
		LcdClear();
		Lcd("CNT = ");
		LcdDec(TCC0.CNT / 4);						// jeden przeskok to 4 impulsy
		_delay_ms(100);								// czekanie 100ms
	}
}